HC = require 'lib/HC'

function love.load()
    if os.getenv("LOCAL_LUA_DEBUGGER_VSCODE") == "1" then
        require("lldebugger").start()
    end

    platform = HC.rectangle(400,400,200,20)

    player = HC.rectangle(490,100,20,20)
    player.velocity = {x = 0, y = 0}
    player.speed = 300
    player.gravity = 500
    player.jumping = false
    player.jump = 300
    player.grounded = false  
end

function love.keypressed(key, scancode, isrepeat)
    if key == "escape" then
       love.event.quit()
    elseif key == "r" then
        platform:setRotation(0)
        player:moveTo(490, 100)
        player.grounded = false
    end
 end

function love.update(dt)
    if love.keyboard.isDown('z') then
        platform:rotate(1 * dt)
    elseif love.keyboard.isDown('x') then
        platform:rotate(-1 * dt)
    end
    
    if love.keyboard.isDown('right') then
        player.velocity.x = player.speed 
    elseif love.keyboard.isDown('left') then
        player.velocity.x = -player.speed
    elseif not player.jumping then
        player.velocity.x = 0
    end

    player.jumping = love.keyboard.isDown('space')

    if player.jumping and player.grounded then
        player.velocity.y = -player.jump
        player.grounded = false
    end

    player.velocity.y = player.velocity.y + player.gravity * dt

    local cx, cy = player:center()

    player:move(player.velocity.x * dt, player.velocity.y * dt)

    for shape, delta in pairs(HC.collisions(player)) do
        player:move(delta.x, delta.y)
        
        if delta.y > 0.01 then
            player.velocity.y = 0
        else
            player.velocity.y = player.gravity
        end

        player.grounded = true
    end  
end

function love.draw()
    platform:draw('fill')
    player:draw()

    love.graphics.print("Radians: " .. tostring(platform:rotation()), 10, 10)
    love.graphics.print("Degrees: " .. tostring(math.floor(math.deg(platform:rotation()))), 10, 30)
end
